<script lang="ts">
import Vue from 'vue';
import CopyButton from '~/components/install/copy-button.vue';

export default Vue.extend({
  components: { CopyButton },
  props: {
    data: {
      type: Object,
      required: true,
      default: () => ({}),
    },
    id: {
      type: String,
      required: true,
    },
  },
});
</script>

<template>
  <article v-if="data" :id="id" class="install-dropdown">
    <div>
      <button
        aria-label="Close installation instructions"
        class="close"
        type="button"
        @click="$emit('closed')"
      >
        {{ data?.close_button }}
        <SlpIcon name="close" variant="product" />
      </button>
    </div>
    <div v-if="data.tip" class="tip">{{ data.tip }}</div>
    <div>
      <SlpTypography tag="h4" variant="heading4">
        {{ data?.instructions?.step1?.text }}
      </SlpTypography>
      <SlpTypography v-if="data.dependency_text" tag="p">
        {{ data.dependency_text }}
      </SlpTypography>
      <div v-if="data.dependency_command" class="code-block">
        <pre class="command" v-html="$md.render(data.dependency_command)"></pre>
        <CopyButton :target="data.dependency_command" />
      </div>
      <div
        v-if="data.instructions && data.instructions.step1"
        class="detail"
        v-html="$md.render(data.instructions.step1.detail1)"
      />
      <div v-if="data.postfix_command" class="code-block">
        <pre class="command" v-html="$md.render(data.postfix_command)"></pre>
        <CopyButton :target="data.postfix_command" />
      </div>
      <div
        v-if="data.instructions && data.instructions.step1"
        class="detail"
        v-html="$md.render(data.instructions.step1.detail2)"
      />
      <SlpTypography tag="h4" variant="heading4">
        {{ data?.instructions?.step2?.text }}
      </SlpTypography>
      <div v-if="data.download_command" class="code-block">
        <pre class="command" v-html="$md.render(data.download_command)"></pre>
        <CopyButton :target="data.download_command" />
      </div>
      <SlpTypography
        v-if="data.preinstall_note"
        tag="div"
        v-html="$md.render(data.preinstall_note)"
      />
      <div v-if="data.preinstall_command" class="code-block">
        <pre class="command" v-html="$md.render(data.preinstall_command)"></pre>
        <CopyButton :target="data.preinstall_command" />
      </div>
      <div
        v-if="data.instructions && data.instructions.step2"
        class="detail"
        v-html="$md.render(data.instructions.step2.detail)"
      ></div>
      <div v-if="data.install_command" class="code-block">
        <pre class="command" v-html="$md.render(data.install_command)"></pre>

        <CopyButton :target="data.install_command" />
      </div>
      <SlpTypography tag="h4" variant="heading4">
        {{ data?.instructions?.step3?.text }}
      </SlpTypography>
      <p
        v-if="data.instructions && data.instructions.step3"
        class="detail"
        v-html="$md.render(data.instructions.step3.detail)"
      ></p>
      <SlpTypography tag="h4" variant="heading4">
        {{ data?.instructions?.step4?.text }}
      </SlpTypography>
      <div
        v-if="data.instructions && data.instructions.step4"
        class="detail"
        v-html="$md.render(data.instructions.step4.detail)"
      ></div>
      <div v-if="data.important_note" class="alert">
        <p>
          <strong>{{ data.important_note.header }}</strong>
          {{ data.important_note.text }}
        </p>
      </div>
      <SlpTypography tag="h4" variant="heading4">
        {{ data?.instructions?.step5?.text }}
      </SlpTypography>
      <p
        v-if="data.instructions && data.instructions.step5"
        class="detail"
        v-html="$md.render(data.instructions.step5.detail)"
      ></p>
      <div class="extra-links">
        <a
          v-if="id === 'raspberry-pi-os'"
          href="https://docs.gitlab.com/omnibus/settings/rpi.html"
          data-ga-name="Raspberry Pi settings"
          data-ga-location="raspberry pi"
          >{{ data?.extra_link?.raspberry_pi }}</a
        >
        <a
          href="https://docs.gitlab.com/omnibus/"
          data-ga-name="troubleshooting"
          :data-ga-location="id"
          >{{ data?.extra_link?.troubleshooting }}</a
        >
        <a
          href="https://docs.gitlab.com/omnibus/installation/index.html"
          data-ga-name="manual installation"
          :data-ga-location="id"
          >{{ data?.extra_link?.manual }}</a
        >
        <!-- We only support CE in Raspberry Pi. This if-statement checks for line_back (which rpi doesnt have) and ce_or_ee value in case someone removes that value in Contentful-->
        <a
          v-if="data.extra_link.cc_or_ee && data.line_back"
          href="/install/ce-or-ee/"
          data-ga-name="download CE or EE"
          :data-ga-location="id"
        >
          {{ data?.extra_link?.cc_or_ee }}
        </a>
      </div>
    </div>
  </article>
</template>

<style scoped lang="scss">
.install-dropdown {
  border: 1px solid $color-surface-400;
  padding: $spacing-32;
  scroll-margin-top: 0;
  background: $color-surface-50;

  .close {
    float: right;
    border: none;
    display: flex;
    align-items: center;
    cursor: pointer;
  }

  h4 {
    margin: $spacing-16 0;
  }

  pre {
    display: inline-block;
  }

  pre.command,
  pre.command:deep pre {
    white-space: pre-line;
    word-break: break-all;
    word-wrap: break-word;
    position: relative;
    margin-top: $spacing-8;

    code {
      padding: 0;
    }
  }
  .detail {
    font-size: 20px;
    :deep {
      p {
        margin: 1em 0;
      }
    }
  }

  .code-block {
    display: flex;
    align-items: center;
    justify-content: space-between;
    position: relative;
  }

  .tip {
    border-left: 5px solid $color-info-300;
    padding: $spacing-16;
    margin-bottom: $spacing-32;
  }

  .alert {
    border-left: 5px solid $color-alert-300;
    padding: $spacing-16;
    margin: $spacing-24 0;
  }

  p {
    margin: $spacing-8 0;
  }

  .extra-links {
    margin-top: $spacing-48;
    display: flex;

    a {
      margin-right: $spacing-24;
      font-size: $text-body-3;
    }
  }
}
</style>
